/* Utils.c generated by valac 0.48.13, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2013 Mario Guerriero <mefrio.g@gmail.com>
*               2017 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <pango/pango.h>

#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

extern gchar* scratch_utils_last_path;
gchar* scratch_utils_last_path = NULL;

GSimpleAction* scratch_utils_action_from_group (const gchar* action_name,
                                                GSimpleActionGroup* action_group);
gchar* scratch_utils_pango_font_description_to_css (PangoFontDescription* font_descr);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GSimpleAction*
scratch_utils_action_from_group (const gchar* action_name,
                                 GSimpleActionGroup* action_group)
{
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* result = NULL;
	g_return_val_if_fail (action_name != NULL, NULL);
	g_return_val_if_fail (action_group != NULL, NULL);
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, action_name);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
	result = _tmp1_;
	return result;
}

gchar*
scratch_utils_pango_font_description_to_css (PangoFontDescription* font_descr)
{
	GString* sb = NULL;
	GString* _tmp0_;
	PangoFontMask mask = 0U;
	PangoFontMask _tmp1_;
	PangoFontMask _tmp5_;
	PangoFontMask _tmp10_;
	PangoFontMask _tmp14_;
	PangoFontMask _tmp16_;
	PangoFontMask _tmp27_;
	GString* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* result = NULL;
	g_return_val_if_fail (font_descr != NULL, NULL);
	_tmp0_ = g_string_new ("");
	sb = _tmp0_;
	mask = pango_font_description_get_set_fields (font_descr);
	_tmp1_ = mask;
	if ((_tmp1_ & PANGO_FONT_MASK_FAMILY) == PANGO_FONT_MASK_FAMILY) {
		const gchar* family = NULL;
		const gchar* _tmp2_;
		GString* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = pango_font_description_get_family (font_descr);
		family = _tmp2_;
		_tmp3_ = sb;
		_tmp4_ = family;
		g_string_append_printf (_tmp3_, "font-family: \"%s\";", _tmp4_);
	}
	_tmp5_ = mask;
	if ((_tmp5_ & PANGO_FONT_MASK_STYLE) == PANGO_FONT_MASK_STYLE) {
		PangoStyle style = 0;
		PangoStyle _tmp6_;
		style = pango_font_description_get_style (font_descr);
		_tmp6_ = style;
		switch (_tmp6_) {
			case PANGO_STYLE_NORMAL:
			{
				GString* _tmp7_;
				_tmp7_ = sb;
				g_string_append (_tmp7_, "font-style: normal;");
				break;
			}
			case PANGO_STYLE_ITALIC:
			{
				GString* _tmp8_;
				_tmp8_ = sb;
				g_string_append (_tmp8_, "font-style: italic;");
				break;
			}
			case PANGO_STYLE_OBLIQUE:
			{
				GString* _tmp9_;
				_tmp9_ = sb;
				g_string_append (_tmp9_, "font-style: bold;");
				break;
			}
			default:
			{
				break;
			}
		}
	}
	_tmp10_ = mask;
	if ((_tmp10_ & PANGO_FONT_MASK_VARIANT) == PANGO_FONT_MASK_VARIANT) {
		PangoVariant variant = 0;
		PangoVariant _tmp11_;
		variant = pango_font_description_get_variant (font_descr);
		_tmp11_ = variant;
		switch (_tmp11_) {
			case PANGO_VARIANT_NORMAL:
			{
				GString* _tmp12_;
				_tmp12_ = sb;
				g_string_append (_tmp12_, "font-variant: normal;");
				break;
			}
			case PANGO_VARIANT_SMALL_CAPS:
			{
				GString* _tmp13_;
				_tmp13_ = sb;
				g_string_append (_tmp13_, "font-variant: small-caps");
				break;
			}
			default:
			{
				break;
			}
		}
	}
	_tmp14_ = mask;
	if ((_tmp14_ & PANGO_FONT_MASK_WEIGHT) == PANGO_FONT_MASK_WEIGHT) {
		gint weight = 0;
		GString* _tmp15_;
		weight = CLAMP ((gint) ((pango_font_description_get_weight (font_descr) / 100) * 100), 100, 900);
		_tmp15_ = sb;
		g_string_append_printf (_tmp15_, "font-weight: %i;", weight);
	}
	_tmp16_ = mask;
	if ((_tmp16_ & PANGO_FONT_MASK_STRETCH) == PANGO_FONT_MASK_STRETCH) {
		PangoStretch stretch = 0;
		PangoStretch _tmp17_;
		stretch = pango_font_description_get_stretch (font_descr);
		_tmp17_ = stretch;
		switch (_tmp17_) {
			case PANGO_STRETCH_NORMAL:
			{
				GString* _tmp18_;
				_tmp18_ = sb;
				g_string_append_printf (_tmp18_, "font-stretch: %s;", "normal");
				break;
			}
			case PANGO_STRETCH_ULTRA_CONDENSED:
			{
				GString* _tmp19_;
				_tmp19_ = sb;
				g_string_append_printf (_tmp19_, "font-stretch: %s;", "condensed");
				break;
			}
			case PANGO_STRETCH_EXTRA_CONDENSED:
			{
				GString* _tmp20_;
				_tmp20_ = sb;
				g_string_append_printf (_tmp20_, "font-stretch: %s;", "extra-condensed");
				break;
			}
			case PANGO_STRETCH_CONDENSED:
			{
				GString* _tmp21_;
				_tmp21_ = sb;
				g_string_append_printf (_tmp21_, "font-stretch: %s;", "condensed");
				break;
			}
			case PANGO_STRETCH_SEMI_CONDENSED:
			{
				GString* _tmp22_;
				_tmp22_ = sb;
				g_string_append_printf (_tmp22_, "font-stretch: %s;", "normal");
				break;
			}
			case PANGO_STRETCH_SEMI_EXPANDED:
			{
				GString* _tmp23_;
				_tmp23_ = sb;
				g_string_append_printf (_tmp23_, "font-stretch: %s;", "semi-expanded");
				break;
			}
			case PANGO_STRETCH_EXPANDED:
			{
				GString* _tmp24_;
				_tmp24_ = sb;
				g_string_append_printf (_tmp24_, "font-stretch: %s;", "expanded");
				break;
			}
			case PANGO_STRETCH_EXTRA_EXPANDED:
			{
				GString* _tmp25_;
				_tmp25_ = sb;
				g_string_append_printf (_tmp25_, "font-stretch: %s;", "extra-expanded");
				break;
			}
			case PANGO_STRETCH_ULTRA_EXPANDED:
			{
				GString* _tmp26_;
				_tmp26_ = sb;
				g_string_append_printf (_tmp26_, "font-stretch: %s;", "ultra-expanded");
				break;
			}
			default:
			{
				break;
			}
		}
	}
	_tmp27_ = mask;
	if ((_tmp27_ & PANGO_FONT_MASK_SIZE) == PANGO_FONT_MASK_SIZE) {
		gint font_size = 0;
		GString* _tmp28_;
		font_size = pango_font_description_get_size (font_descr) / PANGO_SCALE;
		_tmp28_ = sb;
		g_string_append_printf (_tmp28_, "font-size: %dpt;", font_size);
	}
	_tmp29_ = sb;
	_tmp30_ = _tmp29_->str;
	_tmp31_ = g_strdup (_tmp30_);
	result = _tmp31_;
	_g_string_free0 (sb);
	return result;
}

